SystemOrganization addCategory: #'GT-Spotter-EventRecorder-Analysis'!

Trait named: #TGTSpotterDurationView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis'!

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 16:09'!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 10:56'!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

Trait named: #TGTSpotterSessionsTable
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis'!

!TGTSpotterSessionsTable methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 11:03'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Sessions';
		display: [ :anEvent | anEvent sessions ];
		column: 'Start' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each start ] width: 155;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each withPreviewSymbol ]
			width: 57;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		showOnly: 50! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:05'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Close Spotter'! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:19'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Dive In Category: '.
	self categoryTitle
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString | 
			aStream nextPutAll: aString ].
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:18'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Selection: '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Show Preview'! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:54'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'SearchFinished: ';
		nextPutAll: (query ifNil: [ 'no query' ] ifNotNil: [ 'with query' ]);
		nextPutAll: ', ';
		print: self categories size;
		nextPutAll: ' categories, ';
		print: self items size;
		nextPutAll: ' findings'! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:01'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Context Change: '.
	self currentTextHashes 
			ifEmpty: [ aStream nextPutAll: 'no input' ]
			ifNotEmpty: [ :aCollection | 
				aStream 
					print: aCollection size;
					nextPutAll: ' words' ]! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:26'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Act On: '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:22'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Dive Out: '.
	self elementNamePrintOn: aStream.
! !

!GTSpotterRecorderOpenEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Open Spotter'! !

OrderedCollection subclass: #GTSpotterAnnouncements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis'!

!GTSpotterAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:42'!
default
	"self default"
	^ self sessions
				sessionsWithNumberOfInputsGreaterThenOne! !

!GTSpotterAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/29/2015 12:41'!
fromDirectory: aFileReference
	"self fromDirectory: './gt/events/' asFileReference"
	^ self 
		withAll: (GTSpotterEventRecorder materializeObjectsFromDirectory: aFileReference)! !

!GTSpotterAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/30/2015 10:07'!
fromLocalDirectory
	^ self fromDirectory: './gt/events/' asFileReference! !

!GTSpotterAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 10:49'!
sessions
	"self sessions"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				sessionsPerComputer! !

!GTSpotterAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 12:41'!
developerUUIDs
	^ #( 	'58d42da6-c993-4ad1-8624-5fd628793610' 
			'4483f704-6909-45d7-9367-869a5850c3e8'
			'52fe7c39-9c98-4fa7-a883-a8b2cabe84db'
			'69202c73-b32f-4968-aaf1-0666d421ea57'
		)! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 12:42'!
developers
	^ self select: [ :each | self developerUUIDs includes: each computerUUID  ]! !

!GTSpotterAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:21'!
duration
	^ 0 seconds! !

!GTSpotterAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 12:42'!
numberOfComputers
	^ self perComputer size! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 10:25'!
perComputer
	^ (self groupedBy: #computerUUID) as: GTSpotterAnnouncements! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 15:45'!
sessions
	^ GTSpotterSessionsBuilder fromEvents: (
			self flatCollect: #materializedData as: OrderedCollection)! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 10:43'!
sessionsPerComputer
	| group computers |
	group := self perComputer.
	computers := group collect: [ :eachComputer |
		eachComputer sortByTimestamp.
		eachComputer sessions as: GTSpotterComputer.
	] as: GTSpotterComputers.
	^ computers select: #notEmpty! !

!GTSpotterAnnouncements methodsFor: 'sorting' stamp: 'JurajKubelka 3/29/2015 12:42'!
sortByTimestamp
	^ self sort: [ :a :b | a timestamp < b timestamp ]! !

!GTSpotterAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:20'!
start
	^ DateAndTime now! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 12:42'!
users
	^ self select: [ :each | (self developerUUIDs includes: each computerUUID) not ]! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 12:42'!
withoutEmptyComputerUUID
	^ self select: [ :each | each computerUUID notNil and: [ (each computerUUID = 'nil') not ] ]! !

OrderedCollection subclass: #GTSpotterComputers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis'!

!GTSpotterComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 16:37'!
gtInspectorComputersIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Computers';
		display: [ :aComputer | aComputer ];
		column: 'Start' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each start ] 
			width: 155;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] 
			width: 67;
		column: 'Sessions' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] 
			width: 60;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfEvents ] 
			width: 50;
		column: 'Previews' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfPreviews ] 
			width: 60;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Dives Out' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesOut ]
			width: 63;
		column: 'Avg. D-In' 
			evaluated: [ :each | (each avgNumberOfDivesIn printShowingDecimalPlaces: 2)]
			width: 60;
		column: 'Avg. D-Out' 
			evaluated: [ :each | (each avgNumberOfDivesOut printShowingDecimalPlaces: 2) ]
			width: 60;
		showOnly: 50! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:04'!
sessions
	^ self flatCollect: #yourself as: GTSpotterSessions! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:32'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self collect: [ :each | each copy sessionsWithNumberOfInputsGreaterThen: anInteger ]! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:32'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

OrderedCollection subclass: #GTSpotterEventCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis'!

GTSpotterEventCollection subclass: #GTSpotterComputer
	uses: TGTSpotterDurationView + TGTSpotterSessionsTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis'!

GTSpotterComputer class
	uses: TGTSpotterDurationView classTrait + TGTSpotterSessionsTable classTrait
	instanceVariableNames: ''!

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:35'!
avgNumberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesIn) / self size! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:35'!
avgNumberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesOut) / self size! !

!GTSpotterComputer methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 16:03'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Sessions';
		display: [ :aComputer | aComputer ];
		column: 'Start' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each start ] width: 155;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each previewString ]
			width: 57;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Fin. Searches' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 83;
		column: 'Selections' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfUserSelections ]
			width: 70;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Dives Out' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesOut ]
			width: 63;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		showOnly: 50! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesIn	! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesOut! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfEvents
	self ifEmpty: [ ^ 0 ].
	^ self sum: #size! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:30'!
numberOfPreviews
	^ self sessionsWithPreview size! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self select: [ :each | each numberOfContextChanged > anInteger ]! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:32'!
sessionsWithPreview
	^ self select: #isWithPreview! !

!GTSpotterComputer methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:45'!
start
	self ifEmpty: [ ^ 0 ].
	^ self first start! !

!GTSpotterComputer methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:46'!
stop
	self ifEmpty: [ ^ 0 ].
	^ self first stop! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:40'!
contextChanges
	^ self select: #isContextChanged! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:14'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:24'!
divesIn
	^ self select: #isDiveIn! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:24'!
divesOut
	^ self select: #isDiveOut! !

!GTSpotterEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:16'!
duration
	^ self stop - self start! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:55'!
finishedSearches
	^ self select: #isSearchFinished! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:40'!
numberOfContextChanged
	^ self contextChanges size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 12:15'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesIn
	^ self divesIn size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesOut
	^ self divesOut size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:54'!
numberOfFinishedSearches
	^ self finishedSearches size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:43'!
numberOfUserSelections
	^ self userSelections size! !

!GTSpotterEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 3/30/2015 13:15'!
sessionPopupText
	^ String streamContents: [ :aStream |
			aStream
				nextPutAll: 'Duration: ';
				print: self duration;
				cr;
				nextPutAll: 'Events: ';
				print: self size;
				cr;
				nextPutAll: 'Number of user input changes: ';
				print: self numberOfContextChanged;
				cr;
				nextPutAll: 'Number of different search strings: ';
				print: self numberOfDifferentSearchStrings;
				cr;
				nextPutAll: 'Number of finished searches: ';
				print: self numberOfFinishedSearches;
				cr;
				nextPutAll: 'Number of user item selections: ';
				print: self numberOfUserSelections;
				cr;
				nextPutAll: 'Dive in/out: ';
				print: self numberOfDivesIn;
				nextPut: $/;
				print: self numberOfDivesOut;
				cr;
				"using of #i, etc."
				nextPutAll: (self isWithPreview ifTrue: [ 'With Preview' ] ifFalse: [ 'Without Preview' ])
		 ]! !

!GTSpotterEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:45'!
start
	self ifEmpty: [ ^ 0 ].
	^ self first timestamp! !

!GTSpotterEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:16'!
stop
	^ self last timestamp! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:44'!
userSelections
	^ self select: #isUserSelection! !

GTSpotterEventCollection subclass: #GTSpotterSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis'!

!GTSpotterSession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 16:47'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Events';
		display: [ :aSession | aSession ];
		column: 'Object' 
			evaluated: [ :each | each asEventAnalysisString ] width: 300;
		column: 'Image Hash' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHash ] width: 75;
		column: 'Time' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each timestamp ] width: 155;
		column: 'Session Creation Time' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each sessionCreationTime ] width: 155;
		withSmalltalkSearch;
		helpMessage: 'Given your INPUT, it executes: self select: [:each | INPUT ]';
		showOnly: 50! !

!GTSpotterSession methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:19'!
imageHashes
	^ (self collect: #imageHash as: OrderedCollection) removeDuplicates! !

!GTSpotterSession methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:45'!
isWithPreview
	^ (self contains: #isShowPreview) and: [ 
			(self contains: #isHidePreview) not ]! !

!GTSpotterSession methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:50'!
previewString
	^ self isWithPreview
		ifTrue: [ 'yes' ]
		ifFalse: [ 'no' ]! !

!GTSpotterSession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:10'!
searchStrings
	^ ((self select: #isContextChanged)
			flatCollect: #currentTextHashes as: Bag)! !

OrderedCollection subclass: #GTSpotterSessions
	uses: TGTSpotterDurationView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis'!

GTSpotterSessions class
	uses: TGTSpotterDurationView classTrait
	instanceVariableNames: ''!

!GTSpotterSessions methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 3/30/2015 10:36'!
duration
	^ self stop - self start! !

!GTSpotterSessions methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 11:20'!
numberOfEvents
	^ self sum: #size! !

!GTSpotterSessions methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 3/30/2015 10:37'!
sessions
	^ self! !

!GTSpotterSessions methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 3/30/2015 10:37'!
start
	^ (self detectMin: #start) ifNil: [ 0 ] ifNotNil: [ :obj | obj start ]! !

!GTSpotterSessions methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 3/30/2015 10:38'!
stop
	^ (self detectMax: #stop)  ifNil: [ 0 ] ifNotNil: [ :obj | obj stop ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:08'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Category: '.
	self categoryLabel
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString |
			aStream 
				nextPutAll: aString;
				nextPutAll: ' with ';
				print: self elementCountOrZero;
				nextPutAll: ' elements' ]! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Hide Preview'! !

Object subclass: #GTSpotterSessionsBuilder
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis'!

!GTSpotterSessionsBuilder class methodsFor: 'api' stamp: 'JurajKubelka 3/30/2015 15:48'!
fromEvents: aCollection 
	^ self new events: aCollection; sessions! !

!GTSpotterSessionsBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:48'!
events: aCollection 
	events := aCollection! !

!GTSpotterSessionsBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 15:44'!
sessions 
	| borders pairs openOrExit previousAssociation |
	events ifEmpty: [ ^ GTSpotterSessions new ].
	borders := events withIndexCollect: [ :event :index |
		event isOpenOrCloseSpotter 
				ifTrue: [ index -> event ]
				ifFalse: [ nil ]
		 ].
	borders := borders select: [ :each | each notNil ].
	pairs := OrderedCollection new.
	openOrExit := #open.
	previousAssociation := borders first.
	borders do: [ :eachAssociation |
		(openOrExit = #open) 
			ifTrue: [ 
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs addLast: eachAssociation. 
					openOrExit := #exit ] ]
			ifFalse: [ 
				eachAssociation value isCloseSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> eachAssociation. 
					openOrExit := #open ].
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> previousAssociation.
					pairs addLast: eachAssociation.
					openOrExit := #exit ] ].
		previousAssociation := eachAssociation.
	].
	openOrExit = #exit ifTrue: [ pairs removeLast ].
	^ pairs collect: [ :eachPair | | open exit |
		open := eachPair key.
		exit := eachPair value.
		GTSpotterSession withAll: (events copyFrom: open key to: exit key).
		 ] as: GTSpotterSessions.! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:26'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Dive In Element: '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:47'!
asEventAnalysisString
	^ String streamContents: [ :stream |
			self eventAnalysisPrintOn: stream ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:17'!
elementNamePrintOn: aStream
	self elementName 
		ifNil: [ aStream nextPutAll: 'unknown element' ];
		ifNotNil: [ aStream nextPutAll: 'an element' ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:44'!
eventAnalysisPrintOn: aStream
	self printOn: aStream! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:17'!
eventTypePrintOn: aStream
	self eventType
		ifNotNil: [ :aSymbol |
			aStream
				nextPut: $,; 
				space;
				print: aSymbol;
				nextPutAll: ' event' ]! !
